"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const delegate = require("delegates");
class Facade {
    constructor() {
        delegate(this, 'workerContext')
            .access('appName')
            .access('appDir')
            .access('processName')
            .access('env')
            .access('environment')
            .access('hub')
            .method('getService')
            .method('getServiceClass')
            .method('getHub')
            .method('getProxy');
    }
    get workerContext() {
        return Facade.get('workerContext');
    }
    static set(k, v) {
        return Facade.map.set(k, v);
    }
    static get(k) {
        return Facade.map.get(k);
    }
    static getInstance() {
        if (!Facade.instance) {
            Facade.instance = new Facade();
        }
        return Facade.instance;
    }
}
// TODO: Make Facade be a simple Injection temporarily. refactor it: Bring IOC into Pandora.js
Facade.map = new Map();
exports.Facade = Facade;
//# sourceMappingURL=Facade.js.map